use std::path::PathBuf;

use crate::lst_parser::error::SyntaxError;

use super::files::FileId;

#[derive(Debug)]
pub enum Error {
    Syntax(FileId, SyntaxError),
    FailedToOpenFileMod(PathBuf, std::io::Error),
}

impl Error {
    pub fn from_syntax(file: FileId, e: SyntaxError) -> Self {
        Self::Syntax(file, e)
    }
}
