use std::sync::Arc;

use dashmap::{DashMap, DashSet};
use rowan::ast::AstNode;

use super::{
    files::{FileId, Loc},
    nodes,
    registry::ItemPath,
    world_creation_pool::WorkerCtx,
    // world_creation_pool::WorkerCtx,
};

pub struct Module {
    /// is none if this is the root module of the entry point file
    decl: Option<Loc<nodes::Mod>>,
    body: ModuleBody,
    own_path: ItemPath,
    child_modules: Arc<DashMap<String, Arc<Module>>>,
    child_defs: Arc<DashMap<String, Def>>,
}

impl Module {
    pub fn parse_file(ctx: WorkerCtx, file: FileId, decl: Option<Loc<nodes::Mod>>) {
        let f = ctx.files.get(file);

        let tree = f.lst.lock().unwrap();

        let children = (&*tree).syntax().children();
    }
}

struct Def;

enum ModuleBody {
    InLine(Loc<nodes::ModBody>),
    File(FileId),
}
